﻿601,100
602,"temp_tm1xfer"
562,"NULL"
586,
585,
564,
565,"lz\>^ZM6D\1Ma@_9O\H2GrtyqG:E4Cm3WW9A4L5CyVs>fY@N;buj?SVZSDpS^N8p5JF9^P9rMBh<tF=wD\Q0nU_CE^LW5aGED3[5KehEQ^lquC=wjHZd=>Hfg7=En238vC`Tt9hQ<C5B>d[Br4TgbcmsQmbhD4Xsxt;8ijPaogP:d30mu2KbRq0loqrKuWXc?w^Hkn7d"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,
568,""""
570,
571,
569,0
592,0
599,1000
560,0
561,0
590,0
637,0
577,0
578,0
579,0
580,0
581,0
582,0
603,0
572,71

#****Begin: Generated Statements***
#****End: Generated Statements****


# ====================================================================================================
# Process name - backup_using_tm1xfer
#
# Purpose - This process generates a tm1xfer file of the database for use as a backup or to
# migrate the server to another environment.
#
# Prereq that there is NO dbname.zip file in the current db directory. If there is, the proc will complete successfully, but not update
# the file as behind the scenes it is prompting for a replace. 
#
# Maintenance History
# 2013/06/17 Bob Yingling - Created
# ====================================================================================================

# ====================================================================================================
# Begin Boiler Plate Process Logging
# ====================================================================================================
# Define Process to Log
processName=GetProcessName();

logCube = 'process_logs';
cntrlCube = 'cn_control';
sLogDir = CellGetS( cntrlCube, 'Logging_directory','current');
logProcess = 'create_process_log';
timeStart=NOW;
if(dimix('}Clients',tm1user())=0);
    whoRanIt='Scheduled Chore';
else;
    whoRanIt=subst(ATTRS('}Clients',TM1USER(),'}TM1_DefaultDisplayValue'),23,25);
endif;
dateStart = TIMST(timeStart,'\Y \M \d - \h:\i:\s');
elementName = processName | ' - ' | dateStart;
countRecords = 0;
status = 'Not Complete';

#Send parameters to StartLogging
return_value = ExecuteProcess(logProcess,'processName',processName,'elementName',elementName);
#Write status information for Start
CellPutS(status,logCube,elementName,'Status');
CellPutS(dateStart,logCube,elementName,'StartTime');
CellPutS(processName,logCube,elementName,'ProcessName');
CellPutS(status,logCube,processName,'Status');
CellPutS(dateStart,logCube,processName,'StartTime');
CellPutS(processName,logCube,processName,'ProcessName');
CellPutS(whoRanIt,logcube,elementName,'whoRanIt');
CellPutS(whoRanIt,logcube,processName,'whoRanIt');
# ====================================================================================================
# End Boiler Plate Process Logging
# ====================================================================================================

# Set variables

# AIX ======================================
#sPath='/tm1/server10/Custom/TM1Data/';
#sOutput = ' > /tmp/tm1xfer.out';
# Windows =================================
sPath=' "C:\tm1_data\';
sOutput = ' > \temp\tm1xfer.out';
sExe = '"C:\Program Files\ibm\cognos\tm1_64\bin64\tm1xfer"  ';

sServer = 'wwtax';

# Build the command string
sCommand = sExe | sPath | sServer | '"' ;
#sCommand = 'C:\backup\backup.cmd ' |  sPath | sServer;


573,3

#****Begin: Generated Statements***
#****End: Generated Statements****
574,3

#****Begin: Generated Statements***
#****End: Generated Statements****
575,28

#****Begin: Generated Statements***
#****End: Generated Statements****


# run the and wait for return (1)

ExecuteCommand('C:\Program Files\ibm\cognos\tm1_64\bin64\tm1xfer.cmd C:\tm1_data\wwtax',1);

# ====================================================================================================
# Begin Boiler Plate Process Logging
# ====================================================================================================
#Variables
timeFinish=NOW;
elapsedTime=TIMST(timeFinish - timeStart,'\h:\i:\s');
dateFinish = TIMST(timeFinish,'\Y \M \d - \h:\i:\s');
status = 'Complete';
#Write status information for Finish
CELLPUTS(status,logCube,elementName,'Status');
CELLPUTS(dateFinish,logCube,elementName,'FinishTime');
CELLPUTS(elapsedTime,logCube,elementName,'ElapsedTime');
CELLPUTN(countRecords,logCube,elementName,'Records');
CELLPUTS(status,logCube,processName,'Status');
CELLPUTS(dateFinish,logCube,processName,'FinishTime');
CELLPUTS(elapsedTime,logCube,processName,'ElapsedTime');
# ====================================================================================================
# End Boiler Plate Process Logging
# ====================================================================================================
576,CubeAction=1511DataAction=1503CubeLogChanges=0
930,0
638,1
804,0
1217,0
900,
901,
902,
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
